package patient;
import rac.*;
import lrs.*;

public class TAMUFactory extends ALRSRACFactory {

  /**
   * Creates a RAC that only retrieves sane patients, or a NullPatient 
   * if not sane patients exist.
   */
  public IRAContainer makeRAC() {
    return new LRSRAContainer(new IAlgo() {
      public Object emptyCase(LRStruct host, Object... input) {
        // STUDENT TO COMPLETE
        return host.insertFront(input[0]);
      }
      
      public Object nonEmptyCase(LRStruct host, Object... input) {
        // STUDENT TO COMPLETE
        return host.insertFront(input[0]);
      }
    }, new IAlgo() {
  
      // STUDENT TO ADD ANY NECESSARY FIELDS
      private IAlgo retrieveAlgo = this;
      
      public Object emptyCase(LRStruct host, Object... input) {
        // STUDENT TO COMPLETE
        return (new LRStruct()).insertFront(NullPatient.Singleton);
      }
      public Object nonEmptyCase(final LRStruct host, Object... input) {
        // STUDENT TO COMPLETE
        return ((IPatient)host.getFirst()).execute(new IPatientVisitor() {
          public Object saneCase(Patient pHost, Object... param) {
            return host;
          }
          
          public Object insaneCase(Patient pHost, Object... param) {
            return host.getRest().execute(retrieveAlgo);
          }
        });
      }
      
    });
  }
}   
