package brs.visitor;
import brs.*;
import util.*;

/**
 * Maps the set of given ILambda's over the tree.
 * Every lambda is applied to every data element in the list
 * in no specified order.
 * Returns the host tree always.
 */
public class MapBRS implements IVisitor {
  public static final MapBRS Singleton = new MapBRS();
  private MapBRS(){}

  public Object emptyCase(BiTree host, Object... lambdas){
    // STUDENT TO COMPLETE
    return host;
  }


  public Object nonEmptyCase(BiTree host, Object... lambdas){
    // STUDENT TO COMPLETE
    for(Object lambda : lambdas) {
      ((ILambda)lambda).apply(host);
    }
    host.getLeftSubTree().execute(this, lambdas);
    host.getRightSubTree().execute(this, lambdas);
    return host;
  }
}

